/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2007, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.shared.ui.internal.viewmodes.CommonViewMode");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.jdojo.util.Assert");
dojo.require("com.ibm.team.apt.api.client.ICmChangeRequest");
dojo.require("com.ibm.team.apt.api.client.IPlanElementDelta");
dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.client.internal.PlanningAttributeIdentifierImpl");
dojo.require("com.ibm.team.apt.api.ui.structure.IOutplaceMessageProvider");
dojo.require("com.ibm.team.apt.shared.ui.internal.structure.VoidGroupProvider");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.TypedJSMap");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.TypedJSSet");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.LinkElement");
dojo.require("com.ibm.team.rtc.foundation.api.ui.tags.PrimaryLocationTag");

(function() {
var jdojo2= com.ibm.jdojo;
var jdojo= jdojo2.lang.Runtime;
var Assert= jdojo2.util.Assert;
var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var client= api.client;
var ICmChangeRequest= client.ICmChangeRequest;
var Type= client.IPlanElementDelta.Type;
var IPlanItem= client.IPlanItem;
var PlanningAttributeIdentifierImpl= client.internal.PlanningAttributeIdentifierImpl;
var Scope= api.ui.structure.IOutplaceMessageProvider.Scope;
var internal= apt.shared.ui.internal;
var VoidGroupProvider= internal.structure.VoidGroupProvider;
var viewmodes= internal.viewmodes;
var TypedJSMap= viewmodes.TypedJSMap;
var TypedJSSet= viewmodes.TypedJSSet;
var ui= team.rtc.foundation.api.ui;
var model2= ui.model;
var Domain= model2.IViewModel.Domain;
var LinkElement= model2.LinkElement;
var PrimaryLocationTag= ui.tags.PrimaryLocationTag;

var CommonViewMode= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.CommonViewMode", null, {
	"-chains-": { constructor: "manual" },

	//fViewModel: null,

	//fInput: null,

	//fPlanningClient: null,

	//fColumnProvider: null,

	//fGroupProvider: null,

	//fElementInfoCreator: null,

	//fGroupElementCache: null,

	constructor: function(planningClient, config, groupProvider, columnProvider) {
		this.fPlanningClient= planningClient;
		this.fGroupProvider= groupProvider;
		this.fColumnProvider= columnProvider;
		if (columnProvider != null) {
			columnProvider.showHeadersInRoot(this.fGroupProvider instanceof VoidGroupProvider);
		}
		this.setElementInfoCreator(new ElementInfoCreator());
	},

	setElementInfoCreator: function(elementInfoCreator) {
		this.fElementInfoCreator= elementInfoCreator;
	},

	getElementInfoCreator: function() {
		return this.fElementInfoCreator;
	},

	setGroupElementCache: function() {
		if (this.fGroupElementCache == null) {
			this.fGroupElementCache= new TypedJSMap();
		}
	},

	getDependentAttributes: function() {
		var result= [IPlanItem.INCLUSION, IPlanItem.DIRTY, IPlanItem.READ_ONLY_IN_PLAN];
		if (jdojo.implementsInterface(this.fGroupProvider, "com.ibm.team.apt.api.client.IPlanningAttributeDependent")) {
			Array.prototype.push.apply(result, this.fGroupProvider.getDependentAttributes());
		}
		if (this.fColumnProvider != null) {
			var linkProviders= this.fColumnProvider.getLinkProviders();
			var $subject= linkProviders;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var linkProvider= $subject[$count];
				var referenceAttribute= linkProvider.getReferenceAttribute();
				if (referenceAttribute != null) 
					result.push(referenceAttribute);
			}
		}
		return result;
	},

	getCreateHandler: function() {
		if (jdojo.implementsInterface(this.fGroupProvider, "com.ibm.team.rtc.foundation.api.ui.essentials.IModificationHandlerProvider")) 
			return this.fGroupProvider.getCreateHandler();
		return null;
	},

	getMoveHandler: function() {
		if (jdojo.implementsInterface(this.fGroupProvider, "com.ibm.team.rtc.foundation.api.ui.essentials.IModificationHandlerProvider")) 
			return this.fGroupProvider.getMoveHandler();
		return null;
	},

	onChangeUpdateStructure: function(delta, updateAccessor) {
		this.doAddElement(updateAccessor, this.fElementInfoCreator.update(delta, true));
		this.doRemoveElement(updateAccessor, this.fElementInfoCreator.update(delta, false));
	},

	onChanges: function(deltas) {
		this.fViewModel.updateModel(dojo.hitch(this, function(updateAccessor) {
			var removals= [];
			var $subject2= deltas;
			var $length2= $subject2.length;
			for (var $count2= 0; $count2 < $length2; $count2++){
				var delta= $subject2[$count2];
				if (jdojo.implementsInterface(delta.getPlanElement(), "com.ibm.team.apt.api.client.IPlanModel")) {
					continue;
				}
				if (delta.isType(Type.Changed)) {
					this.processModification(delta);
				} else if (delta.isType(Type.Added)) {
					this.processAddition(delta);
				} else if (delta.isType(Type.Removed)) {
					removals.push(delta);
				}
			}
			if (removals.length > 0) {
				this.processRemovals(removals);
			}
			return null;
		}));
	},

	processModification: function(delta) {
		var affectedAttributes= {};
		var $subject3= delta.getAffectedAttributes();
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var identifier= $subject3[$count3];
			affectedAttributes[identifier.getId()]= true;
		}
		var affectsStructure= [false];
		var dependentAttributes= this.getDependentAttributes();
		for (var i= 0; !affectsStructure[0] && i < dependentAttributes.length; i++){
			if (dependentAttributes[i].getId() !== IPlanItem.DIRTY.getId() && dependentAttributes[i].getId() !== IPlanItem.READ_ONLY_IN_PLAN.getId()) {
				var identifier= dependentAttributes[i];
				affectsStructure[0]|= (identifier.getId() in affectedAttributes) && delta.getAttributeDelta(identifier).getOldValue() !== undefined;
			}
		}
		this.fViewModel.updateModel(dojo.hitch(this, function(updateAccessor) {
			var planElement= delta.getPlanElement();
			var entries= updateAccessor.getElementEntries(planElement);
			var $subject4= entries;
			var $length4= $subject4.length;
			for (var $count4= 0; $count4 < $length4; $count4++){
				var entry= $subject4[$count4];
				updateAccessor.update(entry, jdojo.getProperties(affectedAttributes));
			}
			if (affectsStructure[0]) {
				this.onChangeUpdateStructure(delta, updateAccessor);
			}
			return null;
		}));
	},

	processAddition: function(delta) {
		this.fViewModel.updateModel(dojo.hitch(this, function(updateAccessor) {
			var planElement= delta.getPlanElement();
			var elementInfo= this.fElementInfoCreator.createElementInfo(planElement, this.getDependentAttributes());
			this.doAddElement(updateAccessor, elementInfo);
			return null;
		}));
	},

	processRemovals: function(removals) {
		this.fViewModel.updateModel(dojo.hitch(this, function(updateAccessor) {
			var $subject5= removals;
			var $length5= $subject5.length;
			for (var $count5= 0; $count5 < $length5; $count5++){
				var delta= $subject5[$count5];
				var elementInfo= this.fElementInfoCreator.createElementInfo(delta.getPlanElement(), this.getDependentAttributes());
				this.doRemoveElement(updateAccessor, elementInfo);
			}
			var $subject6= removals;
			var $length6= $subject6.length;
			for (var $count6= 0; $count6 < $length6; $count6++){
				var delta= $subject6[$count6];
				this.fElementInfoCreator.removeElementInfo(delta.getPlanElement());
			}
			return null;
		}));
	},

	doAddElement: function(updater, elementInfo) {
		this.modifyElement(updater, elementInfo, false);
	},

	doRemoveElement: function(updater, elementInfo) {
		this.modifyElement(updater, elementInfo, true);
	},

	modifyElement: function(updater, elementInfo, remove) {
		var $subject7= elementInfo.computePaths();
		var $length7= $subject7.length;
		for (var $count7= 0; $count7 < $length7; $count7++){
			var elementPath= $subject7[$count7];
			var planElement= elementPath[elementPath.length - 1];
			var planElementPath= elementPath.slice(0, elementPath.length - 1);
			var possibleInplaceGroups= new TypedJSSet();
			var $subject8= elementPath;
			var $length8= $subject8.length;
			for (var $count8= 0; $count8 < $length8; $count8++){
				var currentPlanElement= $subject8[$count8];
				var currentElementInfo= this.getElementInfoCreator().fromCache(currentPlanElement);
				if (currentElementInfo.getAttributeValue(IPlanItem.INCLUSION).isIncluded() || currentElementInfo.getAttributeValue(IPlanItem.DIRTY).isDirty()) {
					var groupId= this.fGroupProvider.getGroupId(currentElementInfo);
					if (groupId != null) {
						possibleInplaceGroups.add(groupId);
					}
				}
			}
			var $subject9= this.getGroupElementPaths(elementPath);
			var $length9= $subject9.length;
			for (var $count9= 0; $count9 < $length9; $count9++){
				var groupElementPath= $subject9[$count9];
				var groupId= null;
				if (groupElementPath.length > 0) {
					groupId= groupElementPath[groupElementPath.length - 1].getGroupElementIdentifier();
				}
				if (groupId == null || possibleInplaceGroups.contains(groupId)) {
					this.doModifyElement(groupElementPath.concat(planElementPath), planElement, elementInfo.getChildrenResolveCallback(), groupId, remove, updater);
				}
			}
		}
		this.doModifyLinks(elementInfo, remove, updater);
	},

	doModifyLinks: function(elementInfo, remove, updateAccessor) {
		if (this.fColumnProvider != null) {
			var linkProviders= this.fColumnProvider.getLinkProviders();
			var $subject10= linkProviders;
			var $length10= $subject10.length;
			for (var $count10= 0; $count10 < $length10; $count10++){
				var linkProvider= $subject10[$count10];
				var referenceAttribute= linkProvider.getReferenceAttribute();
				if (referenceAttribute == null) 
					return ;
				var attributeValue= elementInfo.getAttributeValue(referenceAttribute);
				if (!(jdojo.implementsInterface(attributeValue, "com.ibm.team.apt.api.common.repository.IReferences"))) 
					return ;
				var references= attributeValue.getReferences();
				var $subject11= references;
				var $length11= $subject11.length;
				for (var $count11= 0; $count11 < $length11; $count11++){
					var reference= $subject11[$count11];
					var itemHandle= reference.getItemHandle();
					if (itemHandle == null) 
						continue;
					var targetElement= this.fInput.getPlanElement(itemHandle.getItemId());
					if (targetElement == null) 
						continue;
					var linkElement= new LinkElement(elementInfo.getPlanElement(), targetElement, referenceAttribute);
					if (remove) {
						updateAccessor.removeElement(Domain.Connection, CommonViewMode.EMPTY_PATH, linkElement);
					} else {
						updateAccessor.addEntry(Domain.Connection, CommonViewMode.EMPTY_PATH, linkElement);
					}
				}
			}
		}
	},

	doModifyElement: function(path, planElement, childResolver, groupId, remove, updateAccessor) {
		var tags= this.computeTags(groupId, this.getElementInfoCreator().fromCache(planElement));
		var entry= null;
		if (remove) {
			entry= updateAccessor.getElementEntry(Domain.Content, path, planElement);
			if (entry != null) {
				updateAccessor.removeEntry(entry);
				var $subject12= tags;
				var $length12= $subject12.length;
				for (var $count12= 0; $count12 < $length12; $count12++){
					var tag= $subject12[$count12];
					updateAccessor.clearTag(entry, tag);
				}
			}
		} else {
			entry= updateAccessor.addEntry(Domain.Content, path, planElement);
			var $subject13= tags;
			var $length13= $subject13.length;
			for (var $count13= 0; $count13 < $length13; $count13++){
				var tag= $subject13[$count13];
				updateAccessor.setTag(entry, tag);
			}
			if (childResolver != null && jdojo.implementsInterface(entry, "com.ibm.team.rtc.foundation.api.ui.model.IViewEntry")) {
				entry.setChildrenResolver(childResolver);
			}
		}
		while(entry != null && !entry.isRootEntry()){
			if (jdojo.implementsInterface(entry.getElement(), "com.ibm.team.apt.api.ui.structure.IGroupElement")) {
				updateAccessor.update(entry, null);
			}
			entry= updateAccessor.getParent(entry);
		}
	},

	computeTags: function(groupId, elementInfo) {
		var result= [];
		var inclusion= elementInfo.getAttributeValue(IPlanItem.INCLUSION);
		if (inclusion.isIncluded() && this.isPrimaryGroup(groupId, elementInfo)) {
			result.push(PrimaryLocationTag.INSTANCE);
		}
		return result;
	},

	inputChanged: function(model, newInput) {
		if (!(newInput == null || jdojo.implementsInterface(newInput, "com.ibm.team.apt.api.client.IPlanModel"))) Assert.fail("newInput == null || jdojo.implementsInterface(newInput, \"com.ibm.team.apt.api.client.IPlanModel\")", "CommonViewMode:354");
		if (!(model == null || jdojo.implementsInterface(model, "com.ibm.team.rtc.foundation.api.ui.model.IViewModel"))) Assert.fail("model == null || jdojo.implementsInterface(model, \"com.ibm.team.rtc.foundation.api.ui.model.IViewModel\")", "CommonViewMode:356");
		this.fViewModel= model;
		if (this.fInput != null) {
			this.fInput.removeListener(this);
		}
		this.fInput= newInput;
		if (this.fInput != null) {
			this.fInput.addListener(this);
		}
		if (this.fColumnProvider != null) {
			this.fColumnProvider.inputChanged(this.fViewModel, this.fInput);
		}
		if (this.fGroupProvider != null) {
			this.fGroupProvider.inputChanged(this.fViewModel, this.fInput);
		}
	},

	refreshModel: function(updateAccessor) {
		this.fGroupElementCache= new TypedJSMap();
		this.fElementInfoCreator.clear();
		var planElements= [];
		var attributes= this.getDependentAttributes();
		if (this.fInput != null) {
			var allPlanElements= this.fInput.getAllDefinedPlanElements(attributes);
			var $subject14= allPlanElements;
			var $length14= $subject14.length;
			for (var $count14= 0; $count14 < $length14; $count14++){
				var planElement= $subject14[$count14];
				var cachedElement= this.fElementInfoCreator.createElementInfo(planElement, attributes);
				if (cachedElement != null) {
					planElements.push(cachedElement);
				}
			}
		}
		planElements.sort(function(left, right) {
			return left.fPlanElement.getIdentifier().localeCompare(right.fPlanElement.getIdentifier());
		});
		var defaultGroupIds= this.fGroupProvider.getDefaultGroupIds();
		var $subject15= defaultGroupIds;
		var $length15= $subject15.length;
		for (var $count15= 0; $count15 < $length15; $count15++){
			var groupId= $subject15[$count15];
			var path= [];
			var parent= groupId.getParent();
			while(parent != null){
				path.unshift(this.getGroupElement(parent));
				parent= parent.getParent();
			}
			updateAccessor.addEntry(Domain.Content, path, this.getGroupElement(groupId));
		}
		this.doRefreshHeader(updateAccessor);
		this.doRefreshContent(updateAccessor, planElements);
	},

	provideColumnInfo: function(entry, readAccessor) {
		return this.fColumnProvider != null ? this.fColumnProvider.provideColumnInfo(entry, readAccessor) : null;
	},

	getLinkEntries: function(linkElement, reader) {
		var result= [];
		if (this.fColumnProvider != null) {
			var linkProviders= this.fColumnProvider.getLinkProviders();
			var $subject16= linkProviders;
			var $length16= $subject16.length;
			for (var $count16= 0; $count16 < $length16; $count16++){
				var linkProvider= $subject16[$count16];
				Array.prototype.push.apply(result, linkProvider.getLinkEntries(linkElement, reader));
			}
		}
		return result;
	},

	getElementsToExpandInitially: function() {
		if (this.fViewModel == null) 
			return null;
		return this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var result= [];
			var defaultGroupIds= this.fGroupProvider.getDefaultGroupIds();
			var $subject17= defaultGroupIds;
			var $length17= $subject17.length;
			for (var $count17= 0; $count17 < $length17; $count17++){
				var groupId= $subject17[$count17];
				var groupEntries= readAccessor.getElementEntries(this.getGroupElement(groupId));
				if (groupEntries.length > 0) {
					result.push(groupEntries[0]);
				}
			}
			if (result.length === 0) {
				var n= readAccessor.getEntryNavigator(true);
				var childEntries= n.childEntries(readAccessor.getRootEntry(Domain.Content));
				var $subject18= childEntries;
				var $length18= $subject18.length;
				for (var $count18= 0; $count18 < $length18; $count18++){
					var entry= $subject18[$count18];
					if (jdojo.implementsInterface(entry.getElement(), "com.ibm.team.apt.api.ui.structure.IGroupElement")) {
						result.push(entry);
					}
				}
			}
			return result;
		}));
	},

	getOutplaceReason: function(entry) {
		var result= [];
		if (this.fGroupProvider != null) {
			var element= entry.getElement();
			var elementInfo= null;
			if (jdojo.implementsInterface(element, "com.ibm.team.apt.api.client.IPlanElement")) {
				elementInfo= this.fElementInfoCreator.fromCache(element);
			}
			var inclusion= null;
			if (elementInfo != null) {
				inclusion= elementInfo.getAttributeValue(IPlanItem.INCLUSION);
				if (!inclusion.isIncluded()) {
					var reasons= inclusion.getReasons();
					var $subject19= reasons;
					var $length19= $subject19.length;
					for (var $count19= 0; $count19 < $length19; $count19++){
						var msg= $subject19[$count19];
						var reason= {};
						reason.scope= Scope.NotInPlan;
						reason.message= msg;
						result.push(reason);
					}
				}
			}
			if (inclusion == null || inclusion.isIncluded()) {
				var reason= {};
				reason.scope= Scope.NotInGroup;
				reason.message= this.fGroupProvider.getOutplaceReason(entry, elementInfo);
				if (reason.message != null) {
					result.push(reason);
				}
			}
		}
		return result;
	},

	doRefreshHeader: function(updateAccessor) {
		if (this.fColumnProvider != null) {
			this.fColumnProvider.refreshHeader(updateAccessor);
		}
	},

	doRefreshContent: function(updateAccessor, planElements) {
	},

	getGroupElement: function(groupId) {
		var result= this.fGroupElementCache.get1(groupId);
		if (result == null) {
			result= this.fGroupProvider.createElement(groupId);
			this.fGroupElementCache.put(groupId, result);
		}
		return result;
	},

	isPrimaryGroup: function(groupId, elementInfo) {
		var primaryGroupId= this.fGroupProvider.getGroupId(elementInfo);
		if (groupId == null || primaryGroupId == null) {
			return groupId == null && primaryGroupId == null;
		}
		return groupId.getIdentifier() === primaryGroupId.getIdentifier();
	},

	getGroupElementPaths: function(elementPath) {
		var result= [];
		var groupSet= new TypedJSSet();
		var $subject20= elementPath;
		var $length20= $subject20.length;
		for (var $count20= 0; $count20 < $length20; $count20++){
			var planElement= $subject20[$count20];
			if (planElement.getAdapter(ICmChangeRequest) == null) {
				var groupId= this.fGroupProvider.getGroupId(this.fElementInfoCreator.fromCache(planElement));
				if (groupId != null) {
					groupSet.add(groupId);
				}
			}
		}
		var $subject21= groupSet.toArray();
		var $length21= $subject21.length;
		for (var $count21= 0; $count21 < $length21; $count21++){
			var groupId= $subject21[$count21];
			var groupPath= [];
			while(groupId != null){
				groupPath.unshift(this.getGroupElement(groupId));
				groupId= groupId.getParent();
			}
			result.push(groupPath);
		}
		if (result.length === 0) {
			result.push([]);
		}
		return result;
	},

	$interfaces: {
		'com.ibm.team.apt.api.client.IPlanModelListener': true,
		'com.ibm.team.apt.api.client.IPlanningAttributeDependent': true,
		'com.ibm.team.apt.api.ui.structure.IOutplaceMessageProvider': true,
		'com.ibm.team.rtc.foundation.api.ui.essentials.IModificationHandlerProvider': true,
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModelLinkProvider': true,
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModelTransformer': true
	}
});
var ElementInfoCreator= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.CommonViewMode.ElementInfoCreator", null, {
	"-chains-": { constructor: "manual" },

	//fValues: null,

	constructor: function() {
		this.fValues= {};
	},

	clear: function() {
		this.fValues= {};
	},

	fromCache: function(planElement) {
		var key= planElement.getIdentifier();
		return (key in this.fValues) ? this.fValues[key] : null;
	},

	toCache: function(info) {
		this.fValues[info.getIdentifier()]= info;
		return info;
	},

	createElementInfo: function(planElement, attributes) {
		var attributeValues= {};
		var $subject22= attributes;
		var $length22= $subject22.length;
		for (var $count22= 0; $count22 < $length22; $count22++){
			var identifier= $subject22[$count22];
			if (!(planElement.isDefined(identifier))) Assert.fail("planElement.isDefined(identifier)", "CommonViewMode:575");
			attributeValues[identifier.getId()]= planElement.getAttributeValue(identifier);
		}
		return this.toCache(this.newInstance(planElement, attributeValues));
	},

	removeElementInfo: function(planElement) {
		delete this.fValues[planElement.getIdentifier()];
	},

	update: function(delta, _new) {
		var elementInfo= this.fromCache(delta.getPlanElement());
		if (elementInfo != null) {
			var attributeValues= {};
			var $subject23= jdojo.getProperties(elementInfo.fAttributeValues);
			var $length23= $subject23.length;
			for (var $count23= 0; $count23 < $length23; $count23++){
				var identifier= $subject23[$count23];
				var attributeDelta= delta.getAttributeDelta(new PlanningAttributeIdentifierImpl(identifier));
				if (attributeDelta != null && attributeDelta.getOldValue() !== undefined) {
					attributeValues[identifier]= _new ? attributeDelta.getNewValue() : attributeDelta.getOldValue();
				} else {
					attributeValues[identifier]= elementInfo.fAttributeValues[identifier];
				}
			}
			elementInfo.setAttributeValues(attributeValues);
		}
		return elementInfo;
	},

	newInstance: function(planElement, attributeValues) {
		return new ElementInfo(planElement, attributeValues);
	}
});
var ElementInfo= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.CommonViewMode.ElementInfo", null, {
	"-chains-": { constructor: "manual" },

	//fAttributeValues: null,

	//fPlanElement: null,

	//fChildResolve: null,

	constructor: function(planElement, attributeValues) {
		this.fPlanElement= planElement;
		this.fAttributeValues= attributeValues;
	},

	setAttributeValues: function(attributeValues) {
		this.fAttributeValues= attributeValues;
	},

	getPlanElement: function() {
		return this.fPlanElement;
	},

	setChildrenResolveCallback: function(childResolve) {
		this.fChildResolve= childResolve;
	},

	getChildrenResolveCallback: function() {
		return this.fChildResolve;
	},

	getAttributeValue: function(attributeId) {
		return this.fAttributeValues[attributeId.getId()];
	},

	getIdentifier: function() {
		return this.fPlanElement.getIdentifier();
	},

	computePaths: function() {
		var result= [];
		result.push([this.getPlanElement()]);
		return result;
	},

	debugPathsToString: function(creator) {
		var paths= this.computePaths();
		var result= "";
		for (var i= 0; i < paths.length; i++){
			result+= i + " - ";
			for (var j= 0; j < paths[i].length; j++){
				var planElement= paths[i][j];
				result+= planElement.getItem().getLabel();
				result+= "[";
				var elementInfo= creator.fromCache(planElement);
				var $subject24= jdojo.getProperties(elementInfo.fAttributeValues);
				var $length24= $subject24.length;
				for (var $count24= 0; $count24 < $length24; $count24++){
					var key= $subject24[$count24];
					var object= elementInfo.fAttributeValues[key];
					if (jdojo.implementsInterface(object, "com.ibm.team.apt.api.common.IUIItem")) {
						object= object.getLabel();
					}
					result+= object;
					result+= "|";
				}
				result+= "]";
				result+= "/";
			}
			result+= "\n";
		}
		return result;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true,
		'com.ibm.team.apt.api.ui.structure.IElementInfo': true
	}
});

CommonViewMode.EMPTY_PATH= [];

})();
