/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.shared.ui.internal.viewmodes.ScrumBoardViewMode");

dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.client.IPlanModel");
dojo.require("com.ibm.team.apt.api.ui.essentials.tags.StickyNoteTag");
dojo.require("com.ibm.team.apt.shared.ui.internal.columns.BoardColumnDescriptorFactory");
dojo.require("com.ibm.team.apt.shared.ui.internal.columns.BoardColumnsAndLimitsContainerFactory");
dojo.require("com.ibm.team.apt.shared.ui.internal.structure.WorkflowGroupProvider");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.BoardCardMoveHandler");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.BoardColumnsAndLimitsViewConfiguration");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.TreeViewMode");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel");
dojo.require("com.ibm.team.rtc.foundation.api.ui.tags.PrimaryLocationTag");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.apt.shared.ui.internal.viewmodes", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.shared.ui.internal.viewmodes", "Messages");

var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var client= api.client;
var IPlanItem= client.IPlanItem;
var IPlanModel= client.IPlanModel;
var StickyNoteTag= api.ui.essentials.tags.StickyNoteTag;
var internal= apt.shared.ui.internal;
var columns= internal.columns;
var BoardColumnDescriptorFactory= columns.BoardColumnDescriptorFactory;
var BoardColumnsAndLimitsContainerFactory= columns.BoardColumnsAndLimitsContainerFactory;
var WorkflowGroupProvider= internal.structure.WorkflowGroupProvider;
var viewmodes= internal.viewmodes;
var BoardCardMoveHandler= viewmodes.BoardCardMoveHandler;
var BoardColumnsAndLimitsViewConfiguration= viewmodes.BoardColumnsAndLimitsViewConfiguration;
var TreeViewMode= viewmodes.TreeViewMode;
var GraphElementInfo= TreeViewMode.GraphElementInfo;
var GraphNodeCreator= TreeViewMode.GraphNodeCreator;
var ui= team.rtc.foundation.api.ui;
var Domain= ui.model.IViewModel.Domain;
var PrimaryLocationTag= ui.tags.PrimaryLocationTag;

/**
 * @since 4.0.5
 */
dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.ScrumBoardViewMode", TreeViewMode, {

	//UNKNOWN_STATES_GROUPID: null,

	//UNKNOWN_STATES_GROUP: null,

	//fComparator: null,

	//fConfig: null,

	//fBoardColumnProvider: null,

	constructor: function(planningClient, configuration, groupProvider, columnProvider, factory) {
		this.inherited(arguments, [planningClient, configuration, groupProvider, columnProvider, factory]);
		this.UNKNOWN_STATES_GROUPID= new SpecialGroupIdentifier("_g1rrgZWPEd-pMb0BCC0_Cg");
		this.UNKNOWN_STATES_GROUP= new SpecialGroupElement(Messages.TaskboardViewMode_UNKNOWN_STATES_GROUP, this.UNKNOWN_STATES_GROUPID);
		this.fConfig= this.createBoardConfiguration(configuration, factory);
		this.fComparator= this.createComparator();
		this.fBoardColumnProvider= columnProvider;
		this.setElementInfoCreator(new ScrumboardNodeCreator(this));
	},

	viewModeSupportsOutplacedChildrenOnDemand: function() {
		return false;
	},

	createBoardConfiguration: function(configuration, factory) {
		return new BoardColumnsAndLimitsViewConfiguration(configuration, factory);
	},

	createComparator: function() {
		return new ScrumboardElementSorter();
	},

	getViewConfiguration: function() {
		return this.fConfig;
	},

	inputChanged: function(model, newInput) {
		if (this.fViewModel != null) {
			this.fViewModel.removeComparator(this.fComparator);
		}
		this.inherited("inputChanged", arguments, [model, newInput]);
		if (this.fViewModel != null) {
			this.fViewModel.addComparator(this.fComparator);
		}
	},

	getDependentAttributes: function() {
		return this.inherited("getDependentAttributes", arguments, []).concat(IPlanItem.WORKFLOW_INFO, IPlanModel.WORKFLOW_INFOS, IPlanItem.WORKFLOW_STATE, IPlanItem.WORKFLOW_ACTION, IPlanItem.INCLUSION, IPlanItem.WORKFLOW_STATEGROUP, IPlanItem.ITEM_TYPE, IPlanItem.RANKING, IPlanItem.ID, IPlanItem.WORKFLOW_RESOLUTION);
	},

	doRefreshHeader: function(updateAccessor) {
		this.fBoardColumnProvider.refreshScrumBoardHeader(this.fConfig, this.getDescriptorFactory(), this.fGroupProvider, updateAccessor);
		this.fBoardColumnProvider.configureScrumBoardColumns(this.fBoardColumnProvider.getColumns().getStateGroupColumnList(), updateAccessor);
	},

	getDescriptorFactory: function() {
		return new BoardColumnDescriptorFactory(this.fConfig);
	},

	doRefreshContent: function(updateAccessor, elementInfos) {
		if (this.fConfig.isNewBoard()) {
			this.addStateEntries(updateAccessor, elementInfos);
		}
		this.inherited("doRefreshContent", arguments, [updateAccessor, elementInfos]);
	},

	/**
	 * Gets the current state of a plan element (Takes the work flow action into
	 * account)
	 * 
	 * @param planElement
	 *            The plan element to check on
	 * @return The current state of the plan element
	 */
	getState: function(planElement) {
		var action= planElement.getAttributeValue(IPlanItem.WORKFLOW_ACTION);
		if (action == null) {
			return planElement.getAttributeValue(IPlanItem.WORKFLOW_STATE);
		} else {
			var infosattribute= planElement.getPlanModel().findAttribute(IPlanModel.WORKFLOW_INFOS);
			return infosattribute.getResolvedState(action.getEndState());
		}
	},

	/**
	 * Gets the current state group of a plan element (Takes the work flow
	 * action into account)
	 * 
	 * @param planElement
	 *            The plan element to check on
	 * @return The current state group of the plan element
	 */
	getStateGroup: function(planElement) {
		return planElement.getAttributeValue(IPlanItem.WORKFLOW_STATEGROUP);
	},

	isCrossProjectItem: function(planElement) {
		var itemProjectArea= planElement.getAttributeValue(IPlanItem.PROJECT_AREA);
		var modelProjectArea= planElement.getPlanModel().getAttributeValue(IPlanItem.PROJECT_AREA);
		return itemProjectArea.getItemId() !== modelProjectArea.getItemId();
	},

	isCrossProjectItemFiltered: function(planElement) {
		var stateGroup= this.getStateGroup(planElement);
		var state= this.getState(planElement);
		if (stateGroup == null || state == null) {
			return true;
		}
		return this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var $subject= this.fBoardColumnProvider.getColumns().getStateGroupColumns();
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var stateGroupColumn= $subject[$count];
				var inProjectStateGroup= stateGroupColumn.getColumnDescriptor().getStateGroup();
				if (inProjectStateGroup.getLabel() === stateGroup.getLabel()) {
					if (this.fConfig.isStateGroupFiltered(inProjectStateGroup)) {
						return true;
					} else {
						var $subject2= this.fBoardColumnProvider.getColumns().getStateColumnList(inProjectStateGroup).getColumns(readAccessor);
						var $length2= $subject2.length;
						for (var $count2= 0; $count2 < $length2; $count2++){
							var stateColumn= $subject2[$count2];
							var inProjectState= stateColumn.getColumnDescriptor().getState();
							if (inProjectState.getLabel() === state.getLabel()) {
								if (!this.fConfig.isStateGroupHidingStates(inProjectStateGroup) && this.fConfig.isStateFiltered(inProjectStateGroup, inProjectState.getLabel())) {
									return true;
								} else {
									return false;
								}
							}
						}
					}
				}
			}
			return true;
		}));
	},

	/**
	 * Returns true if the item's state or state group is filtered out, return false otherwise
	 */
	isStateOrStateGroupExcluded: function(planElement) {
		var stateGroup= this.getStateGroup(planElement);
		var state= this.getState(planElement);
		if (stateGroup == null || this.fConfig.isStateGroupFiltered(stateGroup)) {
			return true;
		}
		if (state == null || (!this.fConfig.isStateGroupHidingStates(stateGroup) && this.fConfig.isStateFiltered(stateGroup, state.getLabel()))) {
			return true;
		}
		return false;
	},

	addStateEntries: function(updateAccessor, elementInfos) {
		if (elementInfos.length > 0) {
			var defaultGroupIds= this.fGroupProvider.getDefaultGroupIds();
			if (defaultGroupIds.length > 0) {
				var $subject3= defaultGroupIds;
				var $length3= $subject3.length;
				for (var $count3= 0; $count3 < $length3; $count3++){
					var groupId= $subject3[$count3];
					var groupPath= this.getGroupPath(groupId);
					this.addStateEntry(updateAccessor, groupPath);
				}
			} else {
				this.addStateEntry(updateAccessor, []);
			}
		}
	},

	addStateEntry: function(updateAccessor, groupPath) {
		var $subject4= this.fBoardColumnProvider.getColumns().getStateGroupColumns();
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var stateGroupColumn= $subject4[$count4];
			var stateGroup= stateGroupColumn.getColumnDescriptor().getStateGroup();
			if (!this.fConfig.isStateGroupHidingStates(stateGroup)) {
				var stateGroupPath= [];
				Array.prototype.push.apply(stateGroupPath, groupPath);
				stateGroupPath.push(stateGroupColumn);
				var $subject5= this.fBoardColumnProvider.getColumns().getStateColumnList(stateGroup).getColumns(updateAccessor);
				var $length5= $subject5.length;
				for (var $count5= 0; $count5 < $length5; $count5++){
					var stateColumn= $subject5[$count5];
					var state= stateColumn.getColumnDescriptor().getState();
					var container= BoardColumnsAndLimitsContainerFactory.INSTANCE.createContainer(state);
					updateAccessor.addEntry(Domain.Content, stateGroupPath, container);
				}
			}
		}
	},

	getGroupPath: function(groupId) {
		var path= [];
		var parent= groupId.getParent();
		while(parent != null){
			path.unshift(this.getGroupElement(parent));
			parent= parent.getParent();
		}
		var groupElement= this.getGroupElement(groupId);
		path.push(groupElement);
		return path;
	},

	modifyElement: function(updater, elementInfo, remove) {
		var planElement= elementInfo.getPlanElement();
		var stateGroupColumn= this.getStateGroupColumn(elementInfo);
		if (stateGroupColumn != null) {
			var groupElementPaths= this.getGroupElementPaths([planElement]);
			var $subject6= groupElementPaths;
			var $length6= $subject6.length;
			for (var $count6= 0; $count6 < $length6; $count6++){
				var groupElementPath= $subject6[$count6];
				var path= [];
				Array.prototype.push.apply(path, groupElementPath);
				path.push(stateGroupColumn);
				if (!this.fConfig.isStateGroupHidingStates(stateGroupColumn.getColumnDescriptor().getStateGroup())) {
					Array.prototype.push.apply(path, this.getSubColumnsPath(elementInfo));
				}
				var groupId= null;
				if (groupElementPath.length > 0) {
					groupId= groupElementPath[groupElementPath.length - 1].getGroupElementIdentifier();
				}
				this.doModifyElement(path, planElement, elementInfo.getChildrenResolveCallback(), groupId, remove, updater);
			}
		} else {
			this.doModifyElement([this.UNKNOWN_STATES_GROUP], planElement, elementInfo.getChildrenResolveCallback(), this.UNKNOWN_STATES_GROUPID, remove, updater);
		}
	},

	getSubColumnsPath: function(elementInfo) {
		var path= [];
		if (this.fBoardColumnProvider.getColumns().getStateColumns().length > 0) {
			var stateContainer= this.getStateContainer(elementInfo);
			if (stateContainer != null && this.fConfig.isContainerExists(stateContainer)) {
				path.push(stateContainer);
			}
		}
		return path;
	},

	getElementsToExpandInitially: function() {
		var elementsToExpand= this.inherited("getElementsToExpandInitially", arguments, []);
		Array.prototype.push.apply(elementsToExpand, this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var statesToExpand= [];
			var $subject7= this.fBoardColumnProvider.getColumns().getStateGroupColumns();
			var $length7= $subject7.length;
			for (var $count7= 0; $count7 < $length7; $count7++){
				var stateGroupColumn= $subject7[$count7];
				var $subject8= readAccessor.getElementEntries(stateGroupColumn);
				var $length8= $subject8.length;
				for (var $count8= 0; $count8 < $length8; $count8++){
					var stateGroupEntry= $subject8[$count8];
					statesToExpand.push(stateGroupEntry);
					var $subject9= readAccessor.getChildren(stateGroupEntry);
					var $length9= $subject9.length;
					for (var $count9= 0; $count9 < $length9; $count9++){
						var stateEntry= $subject9[$count9];
						statesToExpand.push(stateEntry);
					}
				}
			}
			return statesToExpand;
		})));
		return elementsToExpand;
	},

	computeTags: function(groupId, elementInfo) {
		if (groupId !== this.UNKNOWN_STATES_GROUPID) {
			var result= this.inherited("computeTags", arguments, [groupId, elementInfo]);
			result.push(new StickyNoteTag(this, this.getViewConfiguration().isNewBoard()));
			return result;
		} else {
			return [PrimaryLocationTag.INSTANCE];
		}
	},

	getStateGroupColumn: function(elementInfo) {
		var stateGroup= elementInfo.getAttributeValue(IPlanItem.WORKFLOW_STATEGROUP);
		var $subject10= this.fBoardColumnProvider.getColumns().getStateGroupColumns();
		var $length10= $subject10.length;
		for (var $count10= 0; $count10 < $length10; $count10++){
			var stateGroupColumn= $subject10[$count10];
			if (stateGroupColumn.getColumnDescriptor().getStateGroup() === stateGroup) 
				return stateGroupColumn;
		}
		return null;
	},

	createMoveHandler: function() {
		return new BoardCardMoveHandler(this);
	},

	getStateContainer: function(elementInfo) {
		var action= elementInfo.getAttributeValue(IPlanItem.WORKFLOW_ACTION);
		var state= null;
		if (action == null) {
			state= elementInfo.getAttributeValue(IPlanItem.WORKFLOW_STATE);
		} else {
			var workflowAttribute= this.fInput.findAttribute(IPlanModel.WORKFLOW_INFOS);
			state= workflowAttribute.getResolvedState(action.getEndState());
		}
		if (state != null && state.getId() !== "null") {
			return BoardColumnsAndLimitsContainerFactory.INSTANCE.createContainer(state);
		}
		return null;
	},

	isGroupedByItem: function(stateGroup, item) {
		if (this.fGroupProvider instanceof WorkflowGroupProvider) {
			var itemContainer= BoardColumnsAndLimitsContainerFactory.INSTANCE.createContainer(item);
			return this.fConfig.isContainerExists(itemContainer);
		}
		return false;
	}
});
var ScrumboardNodeCreator= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.ScrumBoardViewMode.ScrumboardNodeCreator", GraphNodeCreator, {

	constructor: function(viewMode) {
		this.inherited(arguments, [viewMode]);
	},

	newInstance: function(planElement, attributeValues) {
		return new ScrumBoardNode(this, planElement, attributeValues);
	}
});
var ScrumBoardNode= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.ScrumBoardViewMode.ScrumBoardNode", GraphElementInfo, {

	constructor: function(creator, planElement, attributeValues) {
		this.inherited(arguments, [creator, planElement, attributeValues]);
	},

	computePaths: function() {
		var path= [this.getPlanElement()];
		return [path];
	}
});
var ScrumboardElementSorter= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.ScrumBoardViewMode.ScrumboardElementSorter", null, {
	"-chains-": { constructor: "manual" },

	getPriority: function() {
		return ScrumboardElementSorter.DEFAULT_SORT_PRIORITY;
	},

	inputChanged: function(model, newInput) {
	},

	isComparatorProperty: function(property) {
		return false;
	},

	compare: function(e1, e2, readAccessor, forceResort) {
		var o1= e1.getElement();
		var o2= e2.getElement();
		var g1= o1 instanceof SpecialGroupElement;
		var g2= o2 instanceof SpecialGroupElement;
		if (g1 !== g2) {
			return (g1 ? 1 : 0) - (g2 ? 1 : 0);
		} else if (g1 && g2) {
			return o1.getLabel().toLowerCase().localeCompare(o2.getLabel().toLowerCase());
		}
		return undefined;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IViewEntryComparator': true
	}
});
var SpecialGroupIdentifier= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.ScrumBoardViewMode.SpecialGroupIdentifier", null, {
	"-chains-": { constructor: "manual" },

	//fId: null,

	constructor: function(id) {
		this.fId= id;
	},

	getIdentifier: function() {
		return this.fId;
	},

	getParent: function() {
		return null;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true,
		'com.ibm.team.apt.api.ui.structure.GroupElementIdentifier': true
	}
});
var SpecialGroupElement= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.ScrumBoardViewMode.SpecialGroupElement", null, {
	"-chains-": { constructor: "manual" },

	//fIdentifier: null,

	//fLabel: null,

	constructor: function(label, identifier) {
		this.fIdentifier= identifier;
		this.fLabel= label;
	},

	getIdentifier: function() {
		return this.fIdentifier.getIdentifier();
	},

	getGroupElementIdentifier: function() {
		return this.fIdentifier;
	},

	getLabel: function() {
		return this.fLabel;
	},

	getAdapter: function(interfaceType) {
		return null;
	},

	getGroupValue: function() {
		return null;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true,
		'com.ibm.team.apt.api.ui.structure.IGroupElement': true
	}
});

ScrumboardElementSorter.DEFAULT_SORT_PRIORITY= 200;

})();
