/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.tests.filter.ArchivedGroupsFilterTest");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.team.apt.shared.ui.internal.filters.ArchivedGroupsFilter");
dojo.require("com.ibm.team.apt.web.ui.tests.PlanningViewEntryUnitTestCase");
dojo.require("com.ibm.team.apt.web.ui.tests.ViewEntryTreeBuilder");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockContributor");
dojo.require("com.ibm.team.dev.jdojo.jsmock.JSMock");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSAssert");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel");
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryNavigator");

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var team= com.ibm.team;
var apt= team.apt;
var ArchivedGroupsFilter= apt.shared.ui.internal.filters.ArchivedGroupsFilter;
var tests= apt.web.ui.tests;
var PlanningViewEntryUnitTestCase= tests.PlanningViewEntryUnitTestCase;
var ViewEntryTreeBuilder= tests.ViewEntryTreeBuilder;
var MockContributor= tests.mocks.MockContributor;
var jdojo2= team.dev.jdojo;
var JSMock= jdojo2.jsmock.JSMock;
var JSAssert= jdojo2.junit.script.JSAssert;
var foundation= team.rtc.foundation;
var Domain= foundation.api.ui.model.IViewModel.Domain;
var EntryNavigator= foundation.web.ui.model.EntryNavigator;

dojo.declare("com.ibm.team.apt.web.ui.tests.filter.ArchivedGroupsFilterTest", PlanningViewEntryUnitTestCase, {

	testArchivedUserWithOneElementIsFiltered: function() {
		var testObj= new ArchivedGroupsFilter(null);
		var builder= this.aViewEntryBuilder(true, 1);
		this.assertViewEntriesFiltered(true, testObj, builder);
	},

	testArchivedEntryWithNestedElementsIsFiltered: function() {
		var testObj= new ArchivedGroupsFilter(null);
		var builder= this.aViewEntryBuilder(true, 3);
		this.assertViewEntriesFiltered(true, testObj, builder);
	},

	testArchivedEntryWithZeroElementsIsFiltered: function() {
		var testObj= new ArchivedGroupsFilter(null);
		var builder= this.aViewEntryBuilder(true, 0);
		this.assertViewEntriesFiltered(true, testObj, builder);
	},

	testNonArchivedEntryWithZeroElementsIsVisible: function() {
		var testObj= new ArchivedGroupsFilter(null);
		var builder= this.aViewEntryBuilder(false, 0);
		this.assertViewEntriesFiltered(false, testObj, builder);
	},

	testNonArchivedEntryWithNestedElementsIsVisible: function() {
		var testObj= new ArchivedGroupsFilter(null);
		var builder= this.aViewEntryBuilder(false, 3);
		this.assertViewEntriesFiltered(false, testObj, builder);
	},

	aViewEntryBuilder: function(isArchived, numberOfLevels) {
		var groupElement= this.aGroupElement();
		var item= new MockContributor("testUser");
		item.setArchived(isArchived);
		JSMock.doReturn(item).when(groupElement).getGroupValue();
		var builder= new ViewEntryTreeBuilder().root(Domain.Content).child(groupElement);
		for (var i= 0; i < numberOfLevels; i++){
			builder.child(this.aPlanElement());
		}
		return builder;
	},

	assertViewEntriesFiltered: function(expected, testObj, builder) {
		var entries= builder.getFlatList();
		var readAccessor= builder.getReadAccessor(builder.getRoot());
		this.createEntryNavigator(entries, readAccessor);
		for (var i= 0; i < entries.length; i++){
			var entry= entries[i];
			if (jdojo.implementsInterface(entry.getElement(), "com.ibm.team.apt.api.client.IPlanElement") || jdojo.implementsInterface(entry.getElement(), "com.ibm.team.apt.api.ui.structure.IGroupElement")) {
				JSAssert.assertEquals(expected, !testObj.select(entry, readAccessor));
			}
		}
	},

	createEntryNavigator: function(viewEntries, readAccessor) {
		var entryNavigator= JSMock.mock(EntryNavigator);
		JSMock.doReturn(entryNavigator).when(readAccessor).getEntryNavigator(true);
		var current;
		var children;
		for (var i= 0; i < viewEntries.length; i++){
			current= viewEntries[i];
			children= readAccessor.getChildren(current);
			JSMock.doReturn(children).when(entryNavigator).childEntries(current);
			var $subject= children;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var childEntry= $subject[$count];
				JSMock.doReturn(current).when(entryNavigator).parentEntry(childEntry);
			}
		}
	}
});

})();
