/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gadgets.table.ListenerCollection"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.OrderedMap"); //$NON-NLS-1$

(function() {
var OrderedMap= com.ibm.team.rtc.foundation.web.ui.gadgets.table.OrderedMap;

dojo.declare("com.ibm.team.rtc.foundation.web.ui.gadgets.table.ListenerCollection", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	//fListenHandles: null,

	constructor: function() {
		this.fListenHandles= {};
	},

	addListener: function(type, listener) {
		var id= "0"; //$NON-NLS-1$
		var map= this.fListenHandles[type];
		if (map == null) {
			map= new OrderedMap();
		}
		if (map.getSize() > 0) {
			id= (parseInt(map.getIdentifierByIndex(map.getSize() - 1)) + 1).toString();
		}
		map.addElementAtEnd(id, {type: type, listener: listener});
		this.fListenHandles[type]= map;
		return {id: id, type: type, listener: listener, collection: this};
	},

	removeListener: function(handle) {
		var map= this.fListenHandles[handle.type];
		if (map != null) {
			if (map.getElementByIdentifier(handle.id) === handle.listener) {
				map.removeElementByIdentifier(handle.id);
			}
		}
	},

	callListeners: function(type, input) {
		var returnValues= [];
		var map= this.fListenHandles[type];
		if (map != null) {
			var $subject= map.getValueArray();
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var pair= $subject[$count];
				if (pair.type === type) {
					returnValues.push(pair.listener(input));
				}
			}
		}
		return returnValues;
	},

	hasListeners: function(type) {
		var map= this.fListenHandles[type];
		return map != null && map.getSize() > 0;
	}
});

})();
