/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gadgets.table.model.TableViewer"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.AbstractStylableDojoObjectHTMLGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.SecondaryHorizontalScrollbar"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableContainer"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TreeMap"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$

(function() {
var jdojo2= com.ibm.jdojo;
var jdojo= jdojo2.lang.Runtime;
var Assert= jdojo2.util.Assert;
var foundation= com.ibm.team.rtc.foundation;
var Domain= foundation.api.ui.model.IViewModel.Domain;
var gadgets= foundation.web.ui.gadgets;
var AbstractStylableDojoObjectHTMLGadget= gadgets.AbstractStylableDojoObjectHTMLGadget;
var SecondaryHorizontalScrollbar= gadgets.SecondaryHorizontalScrollbar;
var table= gadgets.table;
var TableContainer= table.TableContainer;
var TreeMap= table.TreeMap;
var _Widget= dijit._Widget;

/**
 * The TableViewer is an abstract class interfacing the IViewModelViewer with
 * the intention to be used with a Table or StyledTable
 */
var TableViewer= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gadgets.table.model.TableViewer", AbstractStylableDojoObjectHTMLGadget, { //$NON-NLS-1$

	/**
	 * The model with which the viewer interacts
	 */
	//fViewModel: null,

	/**
	 * The container which controls the HTML output
	 */
	//fTableContainer: null,

	/**
	 * Contains a list of IHTMLGadgets by IViewEntry Identifiers
	 */
	//fViewEntryIdtoHTMLGadget: null,

	//fTaskNoteToIViewEntry: null,

	/**
	 * Contains a list of all gadgets which need to be cleaned up
	 */
	//fGadgetsToRemove: null,

	/**
	 * A map of all elements which need to be expanded and/or evaluated
	 */
	//fInitialExpansionMap: null,

	//fDragOverDocumentHandle: null,

	/**
	 * A basic constructor
	 */
	constructor: function() {
		this.inherited(arguments, []);
		this.fHasSecondaryScrollbar= false;
		this.fTableContainer= new TableContainer();
		this.fTableContainer.setParent(this);
		this.fGadgetsToRemove= [];
		this.fViewEntryIdtoHTMLGadget= new TreeMap();
		this.fInitialExpansionMap= {};
		this.fTaskNoteToIViewEntry= {};
		this.addClass(TableViewer.TABLE_VIEWER_CSS_CLASS);
	},

	setInput: function(viewModel) {
		this.fViewModel= viewModel;
	},

	getViewModel: function() {
		return this.fViewModel;
	},

	beginUpdate: function() {
		this.fTableContainer.allowUpdates(false);
	},

	endUpdate: function() {
		this.fTableContainer.allowUpdates(true);
		while(this.fGadgetsToRemove.length > 0){
			var gadget= this.fGadgetsToRemove.pop();
			if (gadget instanceof _Widget) {
				gadget.destroyRecursive(true);
			} else if (jdojo.implementsInterface(gadget, "com.ibm.team.rtc.foundation.web.IDestroyable")) {
				gadget.destroy();
			}
			if (gadget.getHTMLElement().parentNode != null) {
				gadget.getHTMLElement().parentNode.removeChild(gadget.getHTMLElement());
			}
		}
	},

	refresh: function(viewEntry) {
		this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			if (viewEntry == null || viewEntry.isRootEntry()) {
				this.clear();
				var contentRoot= readAccessor.getRootEntry(Domain.Content);
				if (contentRoot != null) {
					this.fViewEntryIdtoHTMLGadget.setRoot(contentRoot.getIdentifier(), {viewEntry: contentRoot});
					this.fInitialExpansionMap= {};
					this.fInitialExpansionMap[contentRoot.getIdentifier()]= contentRoot;
					var modelTransformer= this.fViewModel.getModelTransformer();
					if (modelTransformer != null) {
						var elements= modelTransformer.getElementsToExpandInitially();
						if (elements != null) {
							var $subject= elements;
							var $length= $subject.length;
							for (var $count= 0; $count < $length; $count++){
								var entry= $subject[$count];
								if (this.fInitialExpansionMap[entry.getIdentifier()] == null) {
									this.fInitialExpansionMap[entry.getIdentifier()]= entry;
								}
							}
						}
					}
					this.evaluateViewEntry(readAccessor, contentRoot);
				}
			} else {
				var treeEntry= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(viewEntry.getIdentifier());
				if (treeEntry == null) {
					this.revealEntry(readAccessor, viewEntry);
					treeEntry= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(viewEntry.getIdentifier());
				} else if (jdojo.implementsInterface(treeEntry.getData(), "com.ibm.team.rtc.foundation.web.ui.gadgets.IRefreshable")) {
					treeEntry.getData().refreshGadget();
				}
				if (treeEntry != null) {
					var previousChild= null;
					var currentChild= null;
					while(treeEntry.getChildren().length > 0){
						currentChild= treeEntry.getChildren()[0];
						if (previousChild === currentChild) {
							break;
						} else {
							this.removeElement(readAccessor, currentChild);
							previousChild= currentChild;
						}
					}
					if (treeEntry.getChildren().length > 0) {
						console.error(TableViewer.TableViewer_COULD_NOT_REMOVE_ALL_CHILD_ELEMENT);
					}
					this.evaluateViewEntry(readAccessor, viewEntry);
				}
			}
			return null;
		}));
	},

	/**
	 * Determines if a view entry is visible
	 * 
	 * @param viewEntry
	 *            The view entry to look up
	 * @return True if visible, false if not
	 */
	isViewEntryVisible: function(viewEntry) {
		return viewEntry.isVisible() || viewEntry.isRootEntry();
	},

	/**
	 * Determines if an entry is collapsed
	 * 
	 * @param viewEntry
	 *            The view entry to get
	 * @return True if collapsed, false if expanded
	 */
	getIsCollaspedViewEntry: function(viewEntry) {
		var gadget= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(viewEntry.getIdentifier());
		if (gadget == null) {
			return true;
		} else if (jdojo.implementsInterface(gadget.getData().gadget, "com.ibm.team.rtc.foundation.web.ui.gadgets.ICollapsible")) {
			return gadget.getData().gadget.isCollapsible() && gadget.getData().gadget.isCollapsed();
		}
		return false;
	},

	/**
	 * Sets an entry as expanded or collapses
	 * 
	 * @param viewEntry
	 *            The view entry to set
	 * @param collaspe
	 *            True collapses the entry, false expands
	 */
	setIsCollaspedViewEntry: function(viewEntry, collaspe) {
		var gadget= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(viewEntry.getIdentifier());
		if (gadget != null) {
			if (jdojo.implementsInterface(gadget.getData().gadget, "com.ibm.team.rtc.foundation.web.ui.gadgets.ICollapsible") && gadget.getData().gadget.isCollapsible()) {
				gadget.getData().gadget.setIsCollapsed(collaspe);
			}
		}
	},

	/**
	 * Evaluates from a viewEntry down
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param viewEntry
	 *            The view entry to evaluate from
	 */
	evaluateViewEntry: function(readAccessor, viewEntry) {
		var navigator= readAccessor.getEntryNavigator(false);
		var childEntries= navigator.childEntries(viewEntry);
		if (childEntries.length > 0) {
			var treeEntry= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(viewEntry.getIdentifier());
			if (treeEntry != null) {
				var batches= this.getBatches(childEntries);
				this.handleViewEntries(readAccessor, batches.shift(), treeEntry);
				window.setTimeout(dojo.hitch(this, function() {
					this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
						while(batches.length > 0){
							var entries= batches.shift();
							if (entries != null) {
								this.handleViewEntries(readAccessor, entries, treeEntry);
							}
						}
						return null;
					}));
				}), 50);
			}
		}
	},

	/**
	 * Processes view entries to be displayed on the board 
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param entries
	 *            Set of entries to evaluate
	 * @param treeEntry
	 *            The view to evaluate from
	 */
	handleViewEntries: function(readAccessor, entries, treeEntry) {
		var $subject2= entries;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var childEntry= $subject2[$count2];
			var isViewEntryVisible= this.isViewEntryVisible(childEntry);
			var isCollapsedViewEntry= this.getIsCollaspedViewEntry(childEntry);
			if (isViewEntryVisible && this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(childEntry.getIdentifier()) == null) {
				this.addElement(readAccessor, treeEntry, childEntry);
			} else if (isViewEntryVisible && !isCollapsedViewEntry) {
				this.evaluateViewEntry(readAccessor, childEntry);
			}
			if (isCollapsedViewEntry) {
				this.setIsCollaspedViewEntry(childEntry, true);
			}
		}
	},

	/**
	 * Batches up view entry add requests 
	 * 
	 * @param viewEntries
	 *            All the view entries which need to be added
	 * 
	 * @return A batched set of viewEntries
	 */
	getBatches: function(viewEntries) {
		var batches= [];
		var batch= [];
		var $subject3= viewEntries;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var entries= $subject3[$count3];
			batch.push(entries);
			if (batch.length === TableViewer.BATCHSIZE) {
				batches.push(batch);
				batch= [];
			}
		}
		if (batch.length > 0) {
			batches.push(batch);
		}
		return batches;
	},

	/**
	 * Resorts all entries under an element
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param viewEntry
	 *            The view entry to resort
	 */
	resortElement: function(readAccessor, viewEntry) {
		Assert.isTrue(false, "Abstract method 'resortElement' invoked");
	},

	/**
	 * Adds a viewEntry to a parentViewEntry
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param treeElement
	 *            The tree element to add the view entry under
	 * @param viewEntry
	 *            The entry to be added
	 */
	addElement: function(readAccessor, treeElement, viewEntry) {
		Assert.isTrue(false, "Abstract method 'addElement' invoked");
	},

	/**
	 * Removes a viewEntry
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param treeElement
	 *            The tree element to remove
	 */
	removeElement: function(readAccessor, treeElement) {
		Assert.isTrue(false, "Abstract method 'removeElement' invoked");
	},

	/**
	 * Updates an entry
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param treeElement
	 *            The tree element to be updated
	 * @param properties
	 *            A list of properties on the entry which need to be updated
	 */
	updateElement: function(readAccessor, treeElement, properties) {
		Assert.isTrue(false, "Abstract method 'updateElement' invoked");
	},

	/**
	 * Function is responsible for clearing and destroying all elements
	 * associated with the dom
	 */
	clear: function() {
		this.fViewEntryIdtoHTMLGadget.clear();
		this.fTableContainer.clear();
	},

	/**
	 * Gets the root element of the HTML representation of the IViewModel
	 * 
	 * @return The root element of the HTML representation of the IViewModel
	 */
	getHTMLElement: function() {
		if (this.fRootElement == null) {
			this.fRootElement= dojo.create("div", {className: this.getClasses()}); //$NON-NLS-1$
			this.fRootElement.appendChild(this.fTableContainer.getHTMLElement());
			if (this.fHasSecondaryScrollbar) {
				this.createSecondaryScrollbarElement();
			}
			this.setupEventHandlers();
		}
		return this.fRootElement;
	},

	//onDragOverDocument: null,

	//fOnResize: null,

	//fHasSecondaryScrollbar: null,

	//fSecondaryScrollbar: null,

	//fSecondaryScrollbarElement: null,

	setupEventHandlers: function() {
		if (this.fDragOverDocumentHandle == null) {
			this.fDragOverDocumentHandle= dojo.connect(window.document, 'dragover', dojo.hitch(this, this.onDragOverDocument)); //$NON-NLS-1$
		}
		if (dojo.isIE && dojo.isIE === 9) {
			this.fOnResize= dojo.connect(window, 'onresize', dojo.hitch(this, function(event) { //$NON-NLS-1$
				this.setContainerSize();
			}));
			var DELAY= 100;
			window.setTimeout(dojo.hitch(this, function() {
				this.setContainerSize();
			}), DELAY);
		}
	},

	/**
	 * Gets an AbstractTableElement from a viewEntry
	 * 
	 * @param viewEntry
	 *            The viewEntry to use for the finding
	 * @return An AbstractTableElement representation of the viewEntry
	 */
	getViewEntryGadget: function(viewEntry) {
		var gadget= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(viewEntry.getIdentifier());
		return gadget == null ? null : gadget.getData().gadget;
	},

	resort: function(viewEntry) {
		this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			this.resortElement(readAccessor, viewEntry);
			return null;
		}));
	},

	/**
	 * Reveals all elements to the current entry
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param entry
	 *            The entry which should be revealed
	 */
	revealEntry: function(readAccessor, entry) {
		if (!entry.isRootEntry()) {
			var parentEntry= readAccessor.getParent(entry);
			if (!parentEntry.isRootEntry()) {
				this.revealEntry(readAccessor, parentEntry);
				this.expandState(readAccessor, parentEntry, true);
			}
		}
	},

	reveal: function(entry) {
		this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			this.revealEntry(readAccessor, entry);
			return null;
		}));
	},

	addLink: function(linkEntry) {
		console.error(TableViewer.TableViewer_ERROR_NOT_IMPLEMENTED_ADD_LINK);
	},

	removeLink: function(linkEntry) {
		console.error(TableViewer.TableViewer_ERROR_NOT_IMPLEMENTED_REMOVE_LINK);
	},

	/**
	 * Expands or collapses a particular state
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param entry
	 *            The entry to expand to collapse
	 * @param expanded
	 *            true expand, false collapses
	 */
	expandState: function(readAccessor, entry, expanded) {
		if (this.getIsCollaspedViewEntry(entry) === expanded) {
			var treeElement= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(entry.getIdentifier());
			if (treeElement == null && expanded) {
				this.revealEntry(readAccessor, entry);
			}
			this.setIsCollaspedViewEntry(entry, !expanded);
		}
		if (expanded) {
			this.evaluateViewEntry(readAccessor, entry);
		}
	},

	setExpandedState: function(entry, expanded) {
		this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			this.expandState(readAccessor, entry, expanded);
			return null;
		}));
	},

	setLoadingState: function(entry, expanded) {
		console.error(TableViewer.TableViewer_ERROR_NOT_IMPLEMENTED_SET_LOADING_STATE);
	},

	setSelectionState: function(entry, selected) {
		console.error(TableViewer.TableViewer_ERROR_NOT_IMPLEMENTED_SET_SELECTION_STATE);
	},

	getExpansionHull: function(entry) {
		return this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			if (this.getIsCollaspedViewEntry(entry)) {
				return null;
			} else {
				var result= {};
				this.getExpansionHullRecursive(readAccessor, entry, result);
				return result;
			}
		}));
	},

	/**
	 * Gets the expansion map for an entry
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param entry
	 *            The view entry which to retrieve the hull from
	 * @param hull
	 *            The hull which is retrieved
	 */
	getExpansionHullRecursive: function(readAccessor, entry, hull) {
		if (hull.expandedChildren == null) {
			hull.expandedChildren= {};
		}
		var $subject4= readAccessor.getChildren(entry);
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var child= $subject4[$count4];
			if (this.getIsCollaspedViewEntry(child)) {
				var childHull= {};
				this.getExpansionHullRecursive(readAccessor, child, childHull);
				hull.expandedChildren[child.getElement().getIdentifier()]= childHull;
			}
		}
	},

	setExpansionHull: function(entry, expansionHull) {
		this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			if (expansionHull == null) {
				this.expandState(readAccessor, entry, false);
			} else {
				this.expandState(readAccessor, entry, true);
				this.setExpansionHullRecursive(readAccessor, entry, expansionHull);
				this.reveal(entry);
			}
			return null;
		}));
	},

	/**
	 * Sets the expansion map for an entry
	 * 
	 * @param readAccessor
	 *            An accessor which is used to look up entries and their related
	 *            values
	 * @param entry
	 *            The view entry which to set the hull in
	 * @param hull
	 *            The hull which to set the entry
	 */
	setExpansionHullRecursive: function(readAccessor, entry, hull) {
		var $subject5= readAccessor.getChildren(entry);
		var $length5= $subject5.length;
		for (var $count5= 0; $count5 < $length5; $count5++){
			var child= $subject5[$count5];
			var childHull= hull.expandedChildren == null ? null : hull.expandedChildren[child.getElement().getIdentifier()];
			if (childHull != null) {
				this.expandState(readAccessor, child, true);
				this.setExpansionHullRecursive(readAccessor, child, childHull);
			} else {
				this.expandState(readAccessor, child, false);
			}
		}
	},

	add: function(parentViewEntry, viewEntry) {
		this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var treeEntry= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(parentViewEntry.getIdentifier());
			this.addElement(readAccessor, treeEntry, viewEntry);
			return null;
		}));
	},

	remove: function(viewEntry) {
		this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var treeEntry= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(viewEntry.getIdentifier());
			this.removeElement(readAccessor, treeEntry);
			return null;
		}));
	},

	update: function(viewEntry, properties) {
		this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var treeEntry= this.fViewEntryIdtoHTMLGadget.getElementByIdentifier(viewEntry.getIdentifier());
			this.updateElement(readAccessor, treeEntry, properties);
			return null;
		}));
	},

	/**
	 * If the pointer is near any edge of the viewport or near the left or right
	 * edge of the table container scroll the table as follows:
	 * 
	 * Vertical scrolling is performed by scrolling the window.
	 * 
	 * Horizontal scrolling will usually be performed by scrolling the table
	 * container but if the browser is narrow enough the window may have a
	 * scrollbar in which case try to scroll the window before scrolling the
	 * table container
	 */
	onDragOverDocument: function(event) {
		var viewPort= dijit.getViewport();
		var tableContainer= this.fRootElement;
		var leftBoundary= 0;
		var rightBoundary= viewPort.w;
		if (tableContainer != null) {
			var containerPosition= dojo.position(tableContainer);
			leftBoundary= Math.max(leftBoundary, containerPosition.x);
			rightBoundary= Math.min(rightBoundary, containerPosition.x + containerPosition.w);
		}
		var leftOffset= event.clientX - leftBoundary;
		var rightOffset= rightBoundary - event.clientX;
		var dx= this.getHorizontalScrollAmount(leftOffset, rightOffset);
		var dy= this.getVerticalScrollAmount(viewPort.h, event.clientY);
		if (dx !== 0) {
			window.scrollBy(dx, 0);
			var viewPortAfterScroll= dijit.getViewport();
			if (viewPort.l === viewPortAfterScroll.l) {
				if (tableContainer != null) {
					tableContainer.scrollLeft= tableContainer.scrollLeft + dx;
				}
			}
		}
		if (dy !== 0) {
			window.scrollBy(0, dy);
		}
		return false;
	},

	getVerticalScrollAmount: function(viewportHeight, yCoordinate) {
		var dy;
		if (yCoordinate < TableViewer.FAST_TRIGGER_AUTOSCROLL) {
			dy= -TableViewer.FAST_AUTOSCROLL_OFFSET;
		} else if (yCoordinate > viewportHeight - TableViewer.FAST_TRIGGER_AUTOSCROLL) {
			dy= TableViewer.FAST_AUTOSCROLL_OFFSET;
		} else if (yCoordinate < TableViewer.MEDIUM_TRIGGER_AUTOSCROLL) {
			dy= -TableViewer.MEDIUM_AUTOSCROLL_OFFSET;
		} else if (yCoordinate > viewportHeight - TableViewer.MEDIUM_TRIGGER_AUTOSCROLL) {
			dy= TableViewer.MEDIUM_AUTOSCROLL_OFFSET;
		} else if (yCoordinate < TableViewer.SLOW_TRIGGER_AUTOSCROLL) {
			dy= -TableViewer.SLOW_AUTOSCROLL_OFFSET;
		} else if (yCoordinate > viewportHeight - TableViewer.SLOW_TRIGGER_AUTOSCROLL) {
			dy= TableViewer.SLOW_AUTOSCROLL_OFFSET;
		} else {
			dy= 0;
		}
		return dy;
	},

	getHorizontalScrollAmount: function(leftOffset, rightOffset) {
		var dx;
		if (leftOffset < TableViewer.FAST_TRIGGER_AUTOSCROLL) {
			dx= -TableViewer.FAST_AUTOSCROLL_OFFSET;
		} else if (rightOffset < TableViewer.FAST_TRIGGER_AUTOSCROLL) {
			dx= TableViewer.FAST_AUTOSCROLL_OFFSET;
		} else if (leftOffset < TableViewer.MEDIUM_TRIGGER_AUTOSCROLL) {
			dx= -TableViewer.MEDIUM_AUTOSCROLL_OFFSET;
		} else if (rightOffset < TableViewer.MEDIUM_TRIGGER_AUTOSCROLL) {
			dx= TableViewer.MEDIUM_AUTOSCROLL_OFFSET;
		} else if (leftOffset < TableViewer.SLOW_TRIGGER_AUTOSCROLL) {
			dx= -TableViewer.SLOW_AUTOSCROLL_OFFSET;
		} else if (rightOffset < TableViewer.SLOW_TRIGGER_AUTOSCROLL) {
			dx= TableViewer.SLOW_AUTOSCROLL_OFFSET;
		} else {
			dx= 0;
		}
		return dx;
	},

	setContainerSize: function() {
		var elementPosition= dojo.position(this.fRootElement);
		var bodyPosition= dojo.contentBox(dojo.body());
		var SPACE_FOR_VERTICAL_SCROLLBAR= 15;
		var MINIMUM_WIDTH= 300;
		var availableWidth= bodyPosition.w - elementPosition.x - SPACE_FOR_VERTICAL_SCROLLBAR;
		availableWidth= Math.max(availableWidth, MINIMUM_WIDTH);
		dojo.style(this.fRootElement, "width", availableWidth + "px"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	/**
	 * Create a second horizontal scrollbar that is displayed whenever the
	 * viewer's own scrollbar is below the bottom of the screen
	 */
	addSecondaryScrollbar: function() {
		this.fHasSecondaryScrollbar= true;
		this.createSecondaryScrollbarElement();
	},

	/**
	 * Creates the secondary scrollbar if the root element exists and the
	 * secondary scrollbar has not yet been created
	 */
	createSecondaryScrollbarElement: function() {
		if (this.fRootElement != null && this.fSecondaryScrollbar == null) {
			this.fSecondaryScrollbar= new SecondaryHorizontalScrollbar(this.fRootElement);
			this.fSecondaryScrollbarElement= this.fSecondaryScrollbar.getHTMLElement();
			this.fRootElement.appendChild(this.fSecondaryScrollbarElement);
		}
	},

	removeSecondaryHorizontalScrollbar: function() {
		if (this.fSecondaryScrollbarElement != null) {
			this.fRootElement.removeChild(this.fSecondaryScrollbarElement);
			this.fSecondaryScrollbarElement= null;
		}
		if (this.fSecondaryScrollbar != null) {
			this.fSecondaryScrollbar.destroy();
			this.fSecondaryScrollbar= null;
		}
	},

	destroy: function() {
		if (this.fDragOverDocumentHandle != null) {
			dojo.disconnect(this.fDragOverDocumentHandle);
			this.fDragOverDocumentHandle= null;
		}
		if (this.fOnResize != null) {
			dojo.disconnect(this.fOnResize);
			this.fOnResize= null;
		}
		this.removeSecondaryHorizontalScrollbar();
	},

	getViewEntryForHTMLGadget: function(gadget) {
		var elements= this.fViewEntryIdtoHTMLGadget.getElements();
		var $subject6= jdojo.getProperties(elements);
		var $length6= $subject6.length;
		for (var $count6= 0; $count6 < $length6; $count6++){
			var key= $subject6[$count6];
			var pair= elements[key];
			var data= pair.getData();
			if (data.gadget === gadget) {
				return data.viewEntry;
			}
		}
		return null;
	},

	/**
	 * Update the secondary scrollbar ( if any ) because the width of the table
	 * has changed
	 */
	tableWidthChanged: function() {
		if (this.fSecondaryScrollbar != null) {
			this.fSecondaryScrollbar.setSecondaryScrollbarAttributes();
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.IDestroyable': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.model.IViewModelViewer': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.model.IViewModelViewer2': true //$NON-NLS-1$
	}
});

TableViewer.TableViewer_COULD_NOT_REMOVE_ALL_CHILD_ELEMENT= "TableViewer: Not all child element could be removed. If this is not fixed, this could causes error when continuing to use this Viewer."; //$NON-NLS-1$
TableViewer.TABLE_VIEWER_CSS_CLASS= "com-ibm-team-rtc-foundation-web-ui-gadgets-table-model-TableViewer"; //$NON-NLS-1$
TableViewer.BATCHSIZE= 150;
TableViewer.SLOW_TRIGGER_AUTOSCROLL= 128;
TableViewer.MEDIUM_TRIGGER_AUTOSCROLL= 32;
TableViewer.FAST_TRIGGER_AUTOSCROLL= 8;
TableViewer.SLOW_AUTOSCROLL_OFFSET= 4;
TableViewer.MEDIUM_AUTOSCROLL_OFFSET= 16;
TableViewer.FAST_AUTOSCROLL_OFFSET= 64;
TableViewer.TableViewer_ERROR_NOT_IMPLEMENTED_ADD_LINK= "Not implemented: addLink"; //$NON-NLS-1$
TableViewer.TableViewer_ERROR_NOT_IMPLEMENTED_REMOVE_LINK= "Not implemented: removeLink"; //$NON-NLS-1$
TableViewer.TableViewer_ERROR_NOT_IMPLEMENTED_SET_SELECTION_STATE= "Not implemented: setSelectionState"; //$NON-NLS-1$
TableViewer.TableViewer_ERROR_NOT_IMPLEMENTED_SET_LOADING_STATE= "Not implemented: setLoadingState"; //$NON-NLS-1$

})();
